// Read1D.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "Read1D.h"
#include <commctrl.h>
#include "obrreq.h"

#define	base_HEX_char	16			// toϊ̊HEXi16j
#define	base_DEC_char	10			// toϊ̊DECi10j
#define	_5MS_TIMER		10			// 5Ms 
#define	_10MS_TIMER		10			// 10Ms
#define	_50MS_TIMER		50			// 50Ms
#define	_100MS_TIMER	100			// 100Ms

#define MAX_LOADSTRING 100

#define DECODE_KIND_SIZE	13

// Global Variables:
HINSTANCE			hInst;			// The current instance
HWND				hwndCB;			// The command bar handle

HWND				ghWnd = 0 ;

char	szInstance[] = {"OBRREADInstance"} ;

BYTE	gbDecodeBuf[1024] ;
WORD	gwRcvCode ;
BYTE	gbLeng ;
DWORD	gdwLeng ;
DWORD	gdwLengs ;
DWORD	gdwLcnt ;
TCHAR	gbLcnt ;
TCHAR	szEndsts[200] ;
TCHAR	tEndsts[20] ;
TCHAR	tDecodeData[1024] ;
TCHAR	szInfsts[20] ;
int		radix ;
HANDLE	hObrStatus;
HANDLE	hKillDispatchThread;
HANDLE 	ghWatchThread ;	
long	glDummy ;
DWORD	KillRxThread = 0;
DWORD	KillRxThread2 = 0;				// 02.12.09 ADD
DWORD	gdwCommThreadID ;
ULONG	WaitReturn;
DWORD	gdwScanlng ;
HWND	ghwnd;


#define	MY_NOTIFYICON	(WM_APP+100)
NOTIFYICONDATA	nIcon ;					// 02.12.25 ADD 
#define IDM_EXIT		WM_USER+300		// 03.01.17 ADD
#define IDM_APPEND		WM_USER+301		// 03.01.17 ADD

WORD	gwRcodeKindTbl[DECODE_KIND_SIZE] = 
		{(WORD)OBR_NONDT,(WORD)OBR_CD39,(WORD)OBR_NW_7,(WORD)OBR_WPCA,(WORD)OBR_WPC
		,(WORD)OBR_UPCA,(WORD)OBR_UPE,(WORD)OBR_IDF,(WORD)OBR_ITF,(WORD)OBR_CD93
		,(WORD)OBR_CD128,(WORD)OBR_MSI,(WORD)OBR_IATA} ;

TCHAR	tRcodeKind_Msg[DECODE_KIND_SIZE][24] = {
							{L"            "},
							{L"OBR_CD39    "},
							{L"OBR_NW_7    "},
							{L"OBR_WPCA    "},
							{L"OBR_WPC     "},
							{L"OBR_UPCA    "},
							{L"OBR_UPE     "},
							{L"OBR_IDF     "},
							{L"OBR_ITF     "},
							{L"OBR_CD93    "},
							{L"OBR_CD128   "},
							{L"OBR_MSI     "},
							{L"OBR_IATA    "}
 };

struct	m_tbl	ObrModeTbl	 = {		/* 샂[h e[u			*/
			OBR_ALL,
			OBR_RESV, OBR_CD39MIN,  OBR_CD39MAX,  OBR_39SON,  OBR_CHKDOFF, OBR_CHKKON,
			OBR_RESV, OBR_NW_7MIN,  OBR_NW_7MAX,  OBR_NWSON,  OBR_CHKDOFF, OBR_CHKKOFF,
			OBR_RESV, OBR_WPCAMIN,  OBR_WPCAMAX,  OBR_OUTOFF, OBR_CHKDON,  OBR_CHKKON,
			OBR_RESV, OBR_WPC_MIN,  OBR_WPC_MAX,  OBR_OUTOFF, OBR_CHKDON,  OBR_CHKKON,
			OBR_RESV, OBR_UPCAMIN,  OBR_UPCAMAX,  OBR_OUTOFF, OBR_CHKDON,  OBR_CHKKON,
			OBR_RESV, OBR_UPC_MIN,  OBR_UPC_MAX,  OBR_UPAOFF, OBR_CHKDON,  OBR_CHKKON,
			OBR_RESV, OBR_IDF_MIN,  OBR_IDF_MAX,  OBR_OUTOFF, OBR_CHKDON,  OBR_CHKKON,
			OBR_RESV, OBR_ITF_MIN,  OBR_ITF_MAX,  OBR_OUTOFF, OBR_CHKDON,  OBR_CHKKON,
			OBR_RESV, OBR_CD93DEF,  OBR_CD93MAX,  OBR_OUTOFF, OBR_CHKDON,  OBR_CHKKOFF,
			OBR_RESV, OBR_C128DEF,  OBR_C128MAX,  OBR_128AON, OBR_CHKDON,  OBR_CHKKOFF,
			OBR_RESV, OBR_MSI_MIN,  OBR_MSI_MAX,  OBR_OUTOFF, OBR_CHKDON,  OBR_CHKKON,
			OBR_RESV, OBR_IATA_MIN0,OBR_IATA_MAX, OBR_OUTOFF, OBR_CHKDOFF, OBR_CHKKON,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_TYPE1, OBR_GAINL, OBR_BUZON, OBR_LEDEROF, OBR_BUFOBR,
			OBR_ENDCR, OBR_NORM,OBR_NULLDATA,
			OBR_CHKCNT,OBR_READCNT,
			OBR_TOTALTIMER,OBR_NOFILTER,OBR_DEFFILTERTIM,OBR_OFFTIMER
	};

DWORD	gdwDataTbl[200] = {0,0,0} ;

DWORD	gdwDspSw = 0 ;					// 03.02.13 ADD
TCHAR	tszIni_DefFileName[50] = L"\\FlashDisk\\Casio\\OBRREADTOOL.ini" ;	// 03.02.13 ADD
char	szDisplayOn[] = {"Display On"} ;		// ǎc[\N 03.02.13 ADD
char	szDisplayOff[] = {"Display Off"} ;		// ǎc[\N 03.02.13 ADD
HANDLE	hIniFile ;								// ǎc[init@C̃nh@03.02.13 ADD
char	cInData_buf[800] ;						// ini̧ٓǂݍޯ̧ 03.02.13 ADD


// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass	(HINSTANCE, LPTSTR);
BOOL				InitInstance	(HINSTANCE, int);
LRESULT CALLBACK	WndProc			(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About			(HWND, UINT, WPARAM, LPARAM);
int	Drviniproc(HWND ) ;
LRESULT CALLBACK ScanRead(HWND, UINT, WPARAM, LPARAM) ;
int	Drviniproc(HWND) ;
DWORD WINAPI LoopExproc ( LPSTR ) ;
VOID Dsp_clr(HWND) ;
VOID ReadBarKindDsp(WORD) ;
VOID iniSet(VOID) ;
int StartScanChk(HWND hDlg) ;
void PopupMenuProc(HWND hWnd) ;					// Popup Menu Create 03.01.17 ADD
int TooliniRead(void) ;							// ǎ°ٳ޳\/\ 03.02.13 ADD


int WINAPI WinMain(	HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPTSTR    lpCmdLine,
					int       nCmdShow)
{
	MSG msg;
	HACCEL hAccelTable;
	HANDLE	hMutex ;
	HWND	hPrevWnd ;
	TCHAR	szWindowClass[MAX_LOADSTRING];		// The window class name


	// dN
	hMutex = CreateMutex((LPSECURITY_ATTRIBUTES )NULL,(BOOL)FALSE,(LPCTSTR)szInstance) ;
	if (GetLastError() == ERROR_ALREADY_EXISTS)
	{
		// ɋN
		// Initialize global strings
		LoadString(hInstance, IDC_READ1D, szWindowClass, MAX_LOADSTRING);
		hPrevWnd = FindWindow(szWindowClass,NULL) ;
		if (hPrevWnd) SetForegroundWindow(hPrevWnd) ;
		CloseHandle(hMutex) ;
		return FALSE;
	}



	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_READ1D);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	ReleaseMutex(hMutex) ;
	CloseHandle(hMutex) ;

	return msg.wParam;
}

//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    It is important to call this function so that the application 
//    will get 'well formed' small icons associated with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance, LPTSTR szWindowClass)
{
	WNDCLASS	wc;

    wc.style			= CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc		= (WNDPROC) WndProc;
    wc.cbClsExtra		= 0;
    wc.cbWndExtra		= 0;
    wc.hInstance		= hInstance;
    wc.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_READ1D));
    wc.hCursor			= 0;
    wc.hbrBackground	= (HBRUSH) GetStockObject(WHITE_BRUSH);
    wc.lpszMenuName		= 0;
    wc.lpszClassName	= szWindowClass;

	return RegisterClass(&wc);
}

//
//  FUNCTION: InitInstance(HANDLE, int)
//
//  PURPOSE: Saves instance handle and creates main window
//
//  COMMENTS:
//
//    In this function, we save the instance handle in a global variable and
//    create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
	HWND	hWnd;
	TCHAR	szTitle[MAX_LOADSTRING];			// The title bar text
	TCHAR	szWindowClass[MAX_LOADSTRING];		// The window class name

	hInst = hInstance;		// Store instance handle in our global variable
	// Initialize global strings
	LoadString(hInstance, IDC_READ1D, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance, szWindowClass);

	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	hWnd = CreateWindow(szWindowClass, szTitle, WS_VISIBLE,
		CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance, NULL);

	if (!hWnd)
	{	
		return FALSE;
	}

	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);
	if (hwndCB)
		CommandBar_Show(hwndCB, TRUE);

	return TRUE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	HDC hdc;
	int wmId, wmEvent;
	int	iRet,iRet2 ;
	DWORD	dwMode ;
	PAINTSTRUCT ps;
	TCHAR szHello[MAX_LOADSTRING];
	RECT rt;

	switch (message) 
	{
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			switch (wmId)
			{
				case IDM_APPEND:
					Shell_NotifyIcon(NIM_DELETE,&nIcon) ;	// ICON 폜 03.01.17 ADD
					ShowWindow(hWnd, SW_SHOW);				// 03.01.17 ADD
					SetForegroundWindow(hWnd); 
					iRet = OBRClose();						// OBRDRV Close
					break;
				case IDM_EXIT:
					Shell_NotifyIcon(NIM_DELETE,&nIcon) ;	// ICON 폜 03.01.17 ADD
					SendMessage(hWnd, WM_DESTROY, 0, 0);
					break;
				case IDM_HELP_ABOUT:
				   DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				   break;
				case IDM_FILE_EXIT:
				   DestroyWindow(hWnd);
				   iRet = OBRClose();						// OBRDRV Close 02.12.09 DEL
				   break;
				case IDM_FILE_SCANREADBUF:
					Shell_NotifyIcon(NIM_DELETE,&nIcon) ;	// ICON 폜 02.12.25 ADD
					ShowWindow(hWnd, SW_SHOW);				// 02.12.25 ADD
					ghWnd = hWnd ;
					iniSet() ;								// ini FileǍ AND ݒ
					iRet = StartScanChk(hWnd) ;				// SCANگފJn
					Dsp_clr(hWnd);
					Drviniproc(hWnd) ;
					hWnd = ghWnd ;
					iRet = OBROpen(hWnd,0);
					if (iRet == OBR_ERROR_HOTKEY)
					{
						iRet2 = MessageBox(hWnd, TEXT("ضްo^s")
										,TEXT("OBROpen װ"),MB_RETRYCANCEL);
						if (iRet2 == IDRETRY)
						{
							return TRUE ;
						}
						else
						{
							DestroyWindow(hWnd) ;
							return TRUE;
						}
					}
					if (iRet != 0)
					{
						iRet2 = MessageBox(hWnd, TEXT("OBRײ ")
										,TEXT("OBROpen Error"),MB_OK);
						return TRUE;
					}
					DialogBox(hInst, (LPCTSTR)IDD_DIALOG_READBUF, hWnd, (DLGPROC)ScanRead);
					iRet = OBRClose();							// OBRDRV Close

					break;
				case IDM_FILE_SCANREADKEY:
					iniSet() ;									// ini FileǍ AND ݒ
					dwMode = OBR_ASTOFF ;						// è޳޳o͎w
					iRet = OBRChangeBuffMode((BYTE)dwMode);		// Key Buff Output Setting
					if (iRet != 0)
					{
						Shell_NotifyIcon(NIM_DELETE,&nIcon) ;	// ICON 폜 02.12.25 ADD
						ShowWindow(hWnd, SW_SHOW);				//
						return TRUE;
					}
					iRet = OBROpen(ghWnd,0);
					if (iRet == OBR_ERROR_HOTKEY)
					{
						iRet2 = MessageBox(hWnd, TEXT("ضްo^s")
										,TEXT("OBROpen װ"),MB_RETRYCANCEL);
						if (iRet2 == IDRETRY)
						{
							return TRUE ;
						}
						else
						{
							DestroyWindow(hWnd) ;
							return TRUE;
						}
					}
					if (iRet != 0)
					{
						iRet2 = MessageBox(hWnd, TEXT("OBRײ ")
										,TEXT("OBROpen Error"),MB_OK);
						return TRUE;
					}
					Shell_NotifyIcon(NIM_ADD,&nIcon) ;			// ICON ǉ 02.12.25 ADD
					ShowWindow(hWnd, SW_HIDE);					// 02.12.25 ADD\

					break;
				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
		case WM_CREATE:
			hwndCB = CommandBar_Create(hInst, hWnd, 1);			
			CommandBar_InsertMenubar(hwndCB, hInst, IDM_MENU, 0);
			CommandBar_AddAdornments(hwndCB, 0, 0);
			nIcon.hIcon = (HICON)LoadImage(hInst,MAKEINTRESOURCE(IDI_READ1D),IMAGE_ICON,16,16,0) ;
			nIcon.cbSize = sizeof(NOTIFYICONDATA) ;
			nIcon.uID = 1 ;
			nIcon.hWnd = hWnd ;
			nIcon.uFlags = NIF_MESSAGE | NIF_ICON ;
			nIcon.uCallbackMessage = MY_NOTIFYICON ;

			iRet = TooliniRead() ;
			if (iRet != 1)
			{												// \wȊO ?
				iniSet() ;									// ini FileǍ AND ݒ
				dwMode = OBR_ASTOFF ;						// è޳޳o͎w
				iRet = OBRChangeBuffMode((BYTE)dwMode);		// Key Buff Output Setting
				if (iRet != 0)
				{
					iRet2 = MessageBox(hWnd, TEXT("Output Buff Change failure")
									,TEXT("OBRChangeBuffMode Error"),MB_RETRYCANCEL);
					if (iRet2 == IDRETRY)
					{
						return TRUE ;
					}
					else
					{
						DestroyWindow(hWnd) ;
						return TRUE;
					}
					return TRUE;
				}
				iRet = OBROpen(ghWnd,0);
				if (iRet == OBR_ERROR_HOTKEY)
				{
					iRet2 = MessageBox(hWnd, TEXT("Trigger key registration failure")
									,TEXT("OBROpen Error"),MB_RETRYCANCEL);
					if (iRet2 == IDRETRY)
					{
						return TRUE ;
					}
					else
					{
						DestroyWindow(hWnd) ;
						return TRUE;
					}
				}
				if (iRet != 0)
				{
					iRet2 = MessageBox(hWnd, TEXT("OBR driver open failure")
									,TEXT("OBROpen Error"),MB_OK);
					return TRUE;
				}
				Shell_NotifyIcon(NIM_ADD,&nIcon) ;			// ICON ǉ 02.12.25 ADD
				ShowWindow(hWnd, SW_HIDE);					// 02.12.25 ADD\
				gdwDspSw = 0 ;					// 03.02.13 ADD
			}
			else
			{									// \w
				gdwDspSw = 1 ;					// 03.02.13 ADD
			}

			break;
		case WM_PAINT:
			if (gdwDspSw == 0)
			{
				ShowWindow(hWnd, SW_HIDE);					// \
				gdwDspSw = 1 ;
			}
			else
			{
				hdc = BeginPaint(hWnd, &ps);
				GetClientRect(hWnd, &rt);
				LoadString(hInst, IDS_HELLO, szHello, MAX_LOADSTRING);
				DrawText(hdc, szHello, _tcslen(szHello), &rt, 
					DT_SINGLELINE | DT_VCENTER | DT_CENTER);
				EndPaint(hWnd, &ps);
			}
			break;
		case MY_NOTIFYICON:
			switch(lParam){
				case WM_LBUTTONDOWN:
					PopupMenuProc(hWnd) ;					// Popup Menu Create 03.01.17 ADD
					break;
			}
			break;
				
		
		
		
		case WM_CLOSE:
			Shell_NotifyIcon(NIM_DELETE,&nIcon) ;		// ICON 폜 02.12.25 ADD
			DestroyWindow(hWnd) ;
			break ;

		case WM_DESTROY:
			iRet = OBRClose();				// OBRDRV Close
			CommandBar_Destroy(hwndCB);
			PostQuitMessage(0);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}

// Mesage handler for the About box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	RECT rt, rt1;
	int DlgWidth, DlgHeight;	// dialog width and height in pixel units
	int NewPosX, NewPosY;

	switch (message)
	{
		case WM_INITDIALOG:
			// trying to center the About dialog
			if (GetWindowRect(hDlg, &rt1)) {
				GetClientRect(GetParent(hDlg), &rt);
				DlgWidth	= rt1.right - rt1.left;
				DlgHeight	= rt1.bottom - rt1.top ;
				NewPosX		= (rt.right - rt.left - DlgWidth)/2;
				NewPosY		= (rt.bottom - rt.top - DlgHeight)/2;
				
				// if the About box is larger than the physical screen 
				if (NewPosX < 0) NewPosX = 0;
				if (NewPosY < 0) NewPosY = 0;
				SetWindowPos(hDlg, 0, NewPosX, NewPosY,
					0, 0, SWP_NOZORDER | SWP_NOSIZE);
			}
			return TRUE;

		case WM_COMMAND:
			if ((LOWORD(wParam) == IDOK) || (LOWORD(wParam) == IDCANCEL))
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}

// Mesage handler for the About box.
LRESULT CALLBACK ScanRead(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	RECT rt, rt1;
	int DlgWidth, DlgHeight;	// dialog width and height in pixel units
	int NewPosX, NewPosY;
	int	ii ;					// 02.12.09 ADD



	ghwnd = hDlg ;				// 
	switch (message)
	{
		case WM_INITDIALOG:
			// trying to center the About dialog
			if (GetWindowRect(hDlg, &rt1)) {
				GetClientRect(GetParent(hDlg), &rt);
				DlgWidth	= rt1.right - rt1.left;
				DlgHeight	= rt1.bottom - rt1.top ;
				NewPosX		= (rt.right - rt.left - DlgWidth)/2;
				NewPosY		= (rt.bottom - rt.top - DlgHeight)/2;
				
				// if the About box is larger than the physical screen 
				if (NewPosX < 0) NewPosX = 0;
				if (NewPosY < 0) NewPosY = 0;
				SetWindowPos(hDlg, 0, NewPosX, NewPosY,
					0, 0, SWP_NOZORDER | SWP_NOSIZE);
			}
			return TRUE;

		case WM_COMMAND:
			if ((LOWORD(wParam) == IDOK) || (LOWORD(wParam) == IDCANCEL))
			{
				ii = KillRxThread2 = 0;				// 02.12.09 ADD
			 	SetEvent(hObrStatus);				// 02.12.17 ADD
				KillRxThread = 1;
			 	SetEvent(hObrStatus);
			 	while(1)
			 	{
					if (KillRxThread2 == 1)
					{							// گޒ~׸ON ?
						WaitForSingleObject(hKillDispatchThread, _100MS_TIMER);
						break ;
					}
					WaitForSingleObject(hKillDispatchThread, _100MS_TIMER);
					if (ii > 30) break ;
					ii += 1;
				}

				WaitReturn = WaitForSingleObject(hObrStatus,_100MS_TIMER);
				CloseHandle(ghWatchThread);	
				ghWatchThread = NULL;
				CloseHandle(hObrStatus);
				hObrStatus = NULL;        
				CloseHandle(hKillDispatchThread);
				hKillDispatchThread = NULL;
				
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}


//************************************************************************
// LoopExProc			eXgsگޏ
//************************************************************************
DWORD WINAPI LoopExproc ( LPSTR lpData )
{
	int	iRet,radix ;
	LPTSTR	szRet ;



	SetEvent(hKillDispatchThread) ;

	while(1) {


		WaitReturn = WaitForSingleObject(hObrStatus,_50MS_TIMER);
		if(KillRxThread == 1) break ;
		iRet = OBRGetStat((DWORD *)&gdwLengs,(BYTE *)&gdwLcnt);
		radix = base_HEX_char ;						// HEXi16ijɂ
		szRet = _itow(iRet,&szEndsts[0],radix) ;
		SetDlgItemText(ghwnd,IDC_EDIT_ENDINF,(LPCTSTR)&szEndsts[0]);
		radix = base_HEX_char ;						// HEXi16ijɂ
		iRet = (int)gdwLcnt ;
		if (gdwLcnt == 0) continue ;

								// ǂݎR[hL


		Dsp_clr(ghwnd) ;						// \NA
		gdwLeng = gbLeng = 0 ;
		memset(&gbDecodeBuf[0],0,1024) ;

		iRet = OBRGets((BYTE *)&gbDecodeBuf[0], (DWORD *)&gwRcvCode, (BYTE *)&gbLeng);

		radix = base_HEX_char ;						// HEXi16ijɂ
		szRet = _itow((int)iRet,&szEndsts[0],radix) ;
		SetDlgItemText(ghwnd,IDC_EDIT_ENDINF,(LPCTSTR)&szEndsts[0]);
		ReadBarKindDsp(gwRcvCode) ;					// ǂݎްގޕ\
		
		radix = base_DEC_char ;						// HEXi10ijɂ 02.10.16 CHG
		iRet = (DWORD)gbLeng ;
		szRet = _itow((int)iRet,&szEndsts[0],radix) ;
		SetDlgItemText(ghwnd,IDC_EDIT_RLNG,(LPCTSTR)&szEndsts[0]);


		MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, (LPCSTR) &gbDecodeBuf[0],
							1024, (TCHAR *) &tDecodeData[0], 1024);
		SetDlgItemText(ghwnd,IDC_EDIT_SCANDATA,(LPCTSTR)&tDecodeData[0]);
	
	}
	SetEvent(hKillDispatchThread) ;
	WaitReturn = WaitForSingleObject(hObrStatus,_100MS_TIMER);
	KillRxThread2 = 1 ;				// گޒ~׸ON 02.12.09 ADD
	// clear information in structure (kind of a "we're done flag")

	return TRUE ;

} 



//**************************************************************************//
//	FUNCTION :	TST_iniproc  Test init  								//
//																			//
//--Variables---------------------------------------------------------------//
//		ϐ		|		^		|I/O|								//
//--------------------------------------------------------------------------//
//	hWnd			| HWND			| I	| nhl						//
//**************************************************************************//
int	Drviniproc(HWND hWnd) 
{

	int	iRet ;
	DWORD dwMode ;


	iRet = OBRClose();							// OBRDRV Close

	dwMode = OBR_BUFOBR ;						// 1D(OBR)ײޯ̧o͎w
	iRet = OBRChangeBuffMode((BYTE)dwMode);		// Drv Buff Setting



	return (iRet) ;

}

VOID Dsp_clr(HWND hWnd)
{
	USHORT	i ;

	for (i=0; i<1024; i++) {
		tDecodeData[i] = L' ' ;
	}
	SetDlgItemText(hWnd,IDC_EDIT_SCANDATA,(LPCTSTR)&tDecodeData[0]);

	for (i=0; i<10; i++) {
		szEndsts[i] = L' ' ;
	}

	SetDlgItemText(hWnd,IDC_EDIT_ENDINF,(LPCTSTR)&szEndsts[0]);

	for (i=0; i<10; i++) {
		szInfsts[i] = L' ' ;
	}

	SetDlgItemText(hWnd,IDC_EDIT_RCODE,(LPCTSTR)&szInfsts[0]);
	SetDlgItemText(hWnd,IDC_EDIT_RLNG,(LPCTSTR)&szInfsts[0]);

	return ;
}

VOID ReadBarKindDsp(WORD wRcvCode) 
{									// ǂݎްގޕ\

	int ii ;

	SetDlgItemText(ghwnd,IDC_EDIT_RCODE,(LPCTSTR)&tRcodeKind_Msg[0][0]);
	for (ii=0;ii<DECODE_KIND_SIZE;ii++)
	{
		if(wRcvCode == gwRcodeKindTbl[ii])
		{
			SetDlgItemText(ghwnd,IDC_EDIT_RCODE,(LPCTSTR)&tRcodeKind_Msg[ii][0]);
			break ;
		}

	}


	return ;

}

int StartScanChk(HWND hDlg)
{
	int	iRet ;
	LPTSTR	szRet ;
	
		iRet = 0;
		KillRxThread = 0;
		hObrStatus = CreateEvent(0,FALSE,FALSE,NULL);	//
		hKillDispatchThread = CreateEvent(0, FALSE, FALSE, NULL);
		if ( ( ghWatchThread =
			CreateThread ( ( LPSECURITY_ATTRIBUTES ) NULL,
					0, 
					( LPTHREAD_START_ROUTINE ) LoopExproc,	// LOOP EXEC گ
					NULL,
					0, &gdwCommThreadID )) == NULL )
		{
			iRet = 9999;
			radix = base_HEX_char ;						// HEXi16ijɂ
			szRet = _itow(iRet,&szEndsts[0],radix) ;
			SetDlgItemText(hDlg,IDC_EDIT_ENDINF,(LPCTSTR)&szEndsts[0]);
		}

		WaitForSingleObject(hKillDispatchThread, 3000);


	return (iRet) ;
}

VOID iniSet(VOID)
{
	int	iRet ;
	
							// ini File Ǎݗv(Ǎ񂾌ʂ̫ĒlƂȂ)
	iRet = OBRClose();					// OBRDRV Close
	iRet = OBRSetIniFileOption() ;		// ini File Ǎ̫Ēlɔf
	iRet = OBRSetDefaultSymbology() ;	// 1D(OBR)ײނӰނ̫Ēlɂ

	
	return ;
}

// Popup Menu Proc
void PopupMenuProc(HWND hWnd)
{ 
	HMENU			hMenu;
	TCHAR			szbuf[32];


	hMenu = CreatePopupMenu();
	ZeroMemory(szbuf, sizeof(szbuf));
	wsprintf(szbuf, TEXT("Ҳ ƭ"));
	AppendMenu(hMenu, MF_STRING, IDM_APPEND, szbuf);
	ZeroMemory(szbuf, sizeof(szbuf));
	wsprintf(szbuf, TEXT("I"));
	AppendMenu(hMenu, MF_STRING, IDM_EXIT, szbuf);

	CheckMenuItem(hMenu,IDM_APPEND,MF_CHECKED);

	// Show Popup Menu
	TrackPopupMenu(hMenu, TPM_LEFTALIGN,
					GetSystemMetrics(SM_CXSCREEN)/2-60, GetSystemMetrics(SM_CYSCREEN)-60,
					 0, hWnd, NULL);
	DestroyMenu(hMenu);
}

//======================================================//
//	OBRRead Tool Display Check Proc						//
//======================================================//
int TooliniRead(void)
{

	int		iRet,iStop_flg,iRaed_cnt1 ;
	DWORD	dwEcode,dwRead_Endlng ;
	BOOL	bRet ;

	hIniFile = CreateFile((LPTSTR)tszIni_DefFileName
						,(GENERIC_READ)
						,FILE_SHARE_READ,NULL,OPEN_EXISTING
						,FILE_ATTRIBUTE_NORMAL, NULL) ;
	if(hIniFile == INVALID_HANDLE_VALUE)
	{
		dwEcode = GetLastError() ;
		return(-1) ;

	}

	iStop_flg = 0 ;							// ~ر
	iRaed_cnt1 = 0 ;
	while (1) {

		bRet = ReadFile(hIniFile,(LPVOID)&cInData_buf[iRaed_cnt1]
						,(DWORD)1
						,(LPDWORD)&dwRead_Endlng, NULL) ;
		if (bRet == TRUE && dwRead_Endlng == 0) {		// ُ̧I[ ?
			iRet = 0 ;
			break ;
		} else if (bRet == FALSE) {						// ُI ?
			iRet = -1 ;
			break ;
		}
		if (cInData_buf[iRaed_cnt1] == '*')
		{
			iRet = memcmp(&cInData_buf[0],&szDisplayOn[0],10);
			if (iRet == 0)
			{								// \Nw
				iRet = 1 ;					// ObrRead Window \
				break ;
			}
			iRet = memcmp(&cInData_buf[0],&szDisplayOff[0],11);
			if (iRet == 0)
			{								// \Nw
				iRet = 0 ;					// ObrRead Window \
				break ;
			}
			iRaed_cnt1 = 0 ;
			continue ;
		} else if ((cInData_buf[iRaed_cnt1] == 0x0d)
					|| (cInData_buf[iRaed_cnt1] == 0x0a)) {		// CR ro LF ?
			iRaed_cnt1 = 0 ;
			continue ;
		}
		iRaed_cnt1 += 1;
	
		if (iStop_flg == 1) break ;
	}


	 bRet = CloseHandle(hIniFile) ;


	return(iRet) ;

}



